=== blitter/wscript ===
#!/usr/bin/env python


def build(bld):
	import os
	obj = bld(
		features = ['c', bld.env['CLIBTYPE']],
		includes = ['.', '../..', '../common'],
		uselib = bld.env['COMMON_USELIB'],
		use = ['gstimxcommon', 'gstimxcompositor'],
		target = 'gstimxblitter',
		vnum = bld.env['GSTIMX_VERSION'],
		source = bld.path.ant_glob('*.c'),
		defines = ['HAVE_CONFIG_H']
	)
	if bld.env['BUILD_FOR_ANDROID']:
		obj.install_path = os.path.join(bld.env['PREFIX'], 'lib')
