=== v4l2src/wscript ===
#!/usr/bin/env python


def configure(conf):
	pass


def build(bld):
	if bld.env['WITH_GSTPHOTOGRAPHY']:
		bld(
			features = ['c', bld.env['CLIBTYPE']],
			includes = ['.', '../..'],
			uselib = bld.env['COMMON_USELIB'],
			use = 'gstimxcommon GSTPHOTOGRAPHY',
			target = 'gstimxv4l2videosrc',
			source = bld.path.ant_glob('*.c'),
			install_path = bld.env['PLUGIN_INSTALL_PATH']
		)
