=== debian/changelog ===
gstreamer-imx (0.11.1-git813756a) trusty; urgency=low

  * Initial release

 -- Francesco Montefoschi <francesco.monte@gmail.com>  Wed, 02 Dec 2015 15:35:56 +0000
